% Implements 2-station method
clear Qinv
%path = 'MHC.POTR'; %Best path

%stackfile = 'stackfile1d.lst';
stackfid = fopen(stackfile);
pathnum = 1;

pathi=0;
while feof(stackfid) == 0
    pathi = pathi+1;
    stackname = fgetl(stackfid);
    stackdata = rsac(stackname);

    samp = lh(stackdata,'DELTA');
    npts = lh(stackdata,'NPTS');
    begf = lh(stackdata,'B');
    endf = lh(stackdata,'E');
    
    rate = round(npts/16);
    stack = stackdata(:,2);
    freq = linspace(begf,endf,npts);
    for r = factor(rate)
        stack = decimate(stack,r);
        freq = decimate(freq,r);
    end
    D = stack';
    Qinv(pathi,:) = D./freq;
end
fclose(stackfid);

[paths,freqnum] = size(Qinv);

Q = 1./(mean(Qinv));
Qvar = var(1./Qinv);
Qstd = std(1./Qinv);
             
% Data vector
d = reshape(Q,pathnum*freqnum,1);
ld = log10(d);

% Weight vector (variance)
w = reshape(Qstd,pathnum*freqnum,1);
lw = 1./log10(w);
e = reshape(Qstd,pathnum*freqnum,1);
le = log10(e);

% Model matrix
f = reshape(freq,pathnum*freqnum,1);
lf = log10(f);
if 0
for r = factor(rate)
    ld = decimate(ld,r); lw = decimate(lw,r); lf = decimate(lf,r);
end
end
G = [(0*lf)+1 lf];

% Get rid of NaN
ldi = find(~isnan(ld)); ldn = ld(ldi);
lwi = find(~isnan(lw)); lwn = lw(lwi);
Gi = find(~isnan(G)); Gn = reshape(G(Gi),length(ldi),2); 

% Invert
[m,mstd,xse,C] = lscov(Gn,ldn,lwn');

% Use the covariance matrix to define confidence region
n=100; p=0:pi/n:2*pi;
[eigvec,eigval] = eig(C);
xy = [cos(p'),sin(p')] * sqrt(eigval) * eigvec'; % Transformation
x = xy(:,1);
y = xy(:,2);

k = sqrt(chi2inv(0.95,2));
x = m(1)+(k*x);
y = m(2)+(k*y);
E = [x y];

figure
plot(lf,ld,'.b',lf,m(1)+m(2).*lf);

figure
plot(10.^x,y,'-k',10^m(1),m(2),'xr'); xlim([0 500]); ylim([0 2]);
