#!/bin/csh

# Master directory
set dir = .
# List of SAC files to operate on
set infile = $dir/EXAMPLE/sacdataZ.lst
# Directory of raw SAC files
set datadir = $dir/EXAMPLE/SacData
set outfile = calcnorm.out

# Lg Parameters
set vlgmin = 2.6
set vlgmax = 3.5
set vlgave = 3.5
set snr = 2
set gamma = 0.5
set mindist = 100
set maxdist = 400

# Go through each file in the list
set file = ` cat $infile `
echo START >! $outfile

@ i = 1
while ( $i <= $#file )

set sacfile = $file[$i]

if ( -e $datadir/$sacfile ) then
cp $datadir/$sacfile .

sac << FIN >! sac.out
macro calcnorm.mac sacfile $sacfile vlgmin $vlgmin vlgmax $vlgmax vlgave $vlgave snr $snr gamma $gamma
quit
FIN

grep OUT= sac.out | cut -d= -f2- >> $outfile

else
  echo SAC file does not exist
endif

\rm $sacfile

@ i++
end

# Sum up the files for each station
awk '$4 >= 0 {print $4}' $outfile | sort | uniq >! sta.lst
set sta = ` cat sta.lst `

@ j = 1
while ( $j <= $#sta )

set staname = $sta[$j]
set staoutfile = $staname.dat

awk '($4 ~ /'$staname'/) && ($9 >= '$snr') && ($13 >= '$mindist') && ($13 <= '$maxdist') {print $7, $13, $14}' $outfile >! $staoutfile

@ j++
end